void doVisualization() {
  int pos;
  int MAX_AGE;
  if (pattern) MAX_AGE = SPLIT_NUM_LEDS + NUM_LEDS / 8;
  else MAX_AGE = NUM_LEDS + NUM_LEDS / 4;

  if (timer_func()) {
    one_color_all();
    for (byte i = 0; i < N_PEAKS; i++) {
      if (heat[i + N_PEAKS] > 0) {

        if (heat[i + N_PEAKS] > 245)  pos = heat[i]; //
        else                          pos = ((127 + (heat[i + N_PEAKS] / 2)) / 255.0) * heat[i];
        if (pattern) {
          leds[(NUM_LEDS / 2) + pos]        = CHSV(heat[i + N_PEAKS * 2], 255, map(heat[i], 0, MAX_AGE, LIGHT_SAT, 0));
          leds[((NUM_LEDS / 2) - 1) - pos]  = CHSV(heat[i + N_PEAKS * 2], 255, map(heat[i], 0, MAX_AGE, LIGHT_SAT, 0));
        } else {
          leds[pos]                         = CHSV(heat[i + N_PEAKS * 2], 255, map(heat[i], 0, MAX_AGE, LIGHT_SAT, 0));
        }
        heat[i]++;  // Прирост возраста
        if ((heat[i] > MAX_AGE) || ((pos >= SPLIT_NUM_LEDS) && (pattern)) || ((pos >= NUM_LEDS) && (pattern == 0))) heat[i + N_PEAKS] = 0;
      }
    }
  }
}
