void loop() {
#if (SCHEM)                                     // Схема от Slenk
#if (MONO_STEREO == 0)                          // Если режим "Моно+Стерео"
  line_mode = digitalRead(BTN_RELAY);           // Опрос пина
#if (LED_INDICATE)                              // Если индикация на диодах активна
  digitalWrite(LED_line, line_mode);            // Включить/выключить диод
#endif
#endif
#else                                           // Схема от technotrasher
  buttonTick();                                 // Опрос и обработка кнопки
#endif
  remoteTick();                                 // Опрос ИК пульта
  eepromTick();                                 // Сохранить настройки
  if (millis() - main_timer > MAIN_LOOP) {      // Главный цикл отрисовки
    animation();                                // Запуск анимации
#if (STRIPE_INDICATE)                           // Если индикация на ленте активна
    if (settings_mode) indicate();              // Индикация режима настроек
#endif
    FastLED.setBrightness(BRIGHTNESS);          // Установить яркость ленты
    if (!IRLremote.receiving()) FastLED.show(); // Если на ИК приёмник не приходит сигнал - отправить значения на ленту (без этого НЕ РАБОТАЕТ!)
    main_timer = millis();                      // Сбросить таймер
  }
}
